<script setup lang="ts">
import { ref, onMounted } from "vue";
import { useQuasar, QForm } from "quasar";
import { useRouter } from "vue-router";
import { useCounterMixin } from "@/stores/mixin";
import http from "@/plugins/http";
import config from "@/app.config";

/**Import type */
import type { QTableProps } from "quasar";
import type { ResponseItems } from "@/modules/06_retirement/interface/response/exitInterview";
import DialogFooter from "@/modules/05_placement/components/PersonalList/DialogFooter.vue";
import DialogHeader from "@/modules/05_placement/components/PersonalList/DialogHeader.vue";

/** use */
const $q = useQuasar(); //ใช้ noti quasar
const router = useRouter();
const mixin = useCounterMixin();
const myForm = ref<QForm>();
const {
  messageError,
  date2Thai,
  showLoader,
  hideLoader,
  success,
  dialogConfirm,
} = mixin;

/** คอลัมน์ */
const rows = ref<ResponseItems[]>([]);
const columns = ref<QTableProps["columns"]>([
  {
    name: "no",
    align: "left",
    label: "ลำดับ",
    sortable: false,
    field: "no",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "fullname",
    align: "left",
    label: "ชื่อ-นามสกุล",
    sortable: true,
    field: "fullname",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "realReason",
    align: "left",
    label: "สาเหตุที่ลาออก",
    sortable: true,
    field: "realReason",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "notExitFactor",
    align: "left",
    label: "ปัจจัยที่ช่วยเปลี่ยนใจไม่อยากลาออก",
    sortable: true,
    field: "notExitFactor",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },

  {
    name: "futureWork",
    align: "left",
    label: "อนาคตกลับจะมาร่วมงานหรือไม่",
    sortable: true,
    field: "futureWork",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "futureWorkReason",
    align: "left",
    label: "เหตุผลที่อยากกลับมาร่วมงาน",
    sortable: true,
    field: "futureWorkReason",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "havejob",
    align: "left",
    label: "มีงานใหม่หรือไม่",
    sortable: true,
    field: "havejob",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "havejobReason",
    align: "left",
    label: "เหตุผลที่มีงานใหม่",
    sortable: true,
    field: "havejobReason",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "appointDate",
    align: "left",
    label: "วันนัดหมายเพื่อสัมภาษณ์",
    sortable: true,
    field: "appointDate",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "datetext",
    align: "left",
    label: "วันที่สร้าง",
    sortable: true,
    field: "datetext",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
]);
/** คอลัมน์ที่แสดง */
const visibleColumns = ref<string[]>([]);

/**
 * ตัวแปร
 */
const dateBreak = ref<Date | null>(null);
const daterow = ref<string | null>("");
const id = ref<string>("");
const filters = ref<ResponseItems[]>([]);
const modal = ref<boolean>(false);
const filterKeyword = ref<string>("");
const filterRef = ref<any>(null);

/** HOOK */
onMounted(async () => {
  await fecthlist();
  if (columns.value) {
    visibleColumns.value = columns.value.map((r: any) => r.name);
  }
});

//นำข้อมูลจาก API มาแสดง
const fecthlist = async () => {
  showLoader();
  await http
    .get(config.API.listExitInterview())
    .then((res: any) => {
      const data = res.data.result;
      let list: ResponseItems[] = [];
      data.map((r: ResponseItems) => {
        list.push({
          datetext: r.createdAt !== null ? date2Thai(r.createdAt) : "-",
          fullname: r.fullname ?? "",
          createdAt: new Date(r.createdAt),
          futureWork: !!r.futureWork,
          futureWorkReason: r.futureWorkReason ?? "",
          havejob: !!r.havejob,
          havejobReason: r.havejobReason ?? "",
          id: r.id ?? "",
          lastUpdatedAt: new Date(r.lastUpdatedAt),
          notExitFactor: r.notExitFactor ?? "",
          realReason: r.realReason ?? "",
          suggestFriends: !!r.suggestFriends,
          suggestFriendsReason: r.suggestFriendsReason ?? "",
          suggestion: r.suggestion ?? "",
          status: r.status ?? "",
          appointDate: date2Thai(r.appointDate),
        });
      });
      rows.value = list;
      filters.value = list;
    })
    .catch((e: any) => {
      messageError($q, e);
    })
    .finally(() => {
      hideLoader();
    });
};

//กําหนดวันนัดหมายเพื่อทําการสัมภาษณ์การลาออก
const saveAppoint = async () => {
  await myForm.value!.validate().then(async (result: boolean) => {
    if (result) {
      dialogConfirm($q, async () => {
        const body = {
          appointDate: dateBreak.value,
        };
        showLoader();
        await http
          .put(config.API.AppointInterview(id.value), body)
          .then((res: any) => {
            success($q, "วันนัดหมายเพื่อทําการสัมภาษณ์การลาออกสำเร็จ");
            closeModal();
          })
          .catch((e) => {
            messageError($q, e);
          })
          .finally(async () => {
            await fecthlist();
            hideLoader();
          });
      });
    }
  });
};

/**
 * ฟังก์ชั่น validate DATE ไทย
 * @param thaiDate วันที่ไทย
 */
const validationDate = (thaiDate: string | null) => {
  if (thaiDate && daterow.value) {
    let a = convertThaiDateToNumeric(thaiDate);
    let b = daterow.value;
    if (a) {
      return a > b;
    }
  }
};

//แปลงเดือนจากตัวเลขเป็นภาษาอ่าน
const convertThaiDateToNumeric = (thaiDate: string) => {
  const parts = thaiDate.split(" ");
  if (parts.length !== 3) return null;
  const [day, month, year] = parts;
  const monthMap: any = {
    "ม.ค.": "01",
    "ก.พ.": "02",
    "มี.ค.": "03",
    "เม.ย.": "04",
    "พ.ค.": "05",
    "มิ.ย.": "06",
    "ก.ค.": "07",
    "ส.ค.": "08",
    "ก.ย.": "09",
    "ต.ค.": "10",
    "พ.ย.": "11",
    "ธ.ค.": "12",
  };
  if (!(month in monthMap)) return null;
  const numericDate = `${year}${monthMap[month]}${day}`;
  return numericDate;
};
/**
 * modal Setting
 */
const openModal = () => (modal.value = true);
const closeModal = () => (modal.value = false);
const resetFilter = () => {
  filterKeyword.value = "";
  filterRef.value.focus();
};
const openModalCalendar = (rows: any) => {
  openModal();
  dateBreak.value = null;
  id.value = rows.id;
  daterow.value = convertThaiDateToNumeric(rows.datetext);
};
</script>
<template v-slot:body="props">
  <div class="toptitle text-dark col-12 row items-center">
    รายการ Exit interview
  </div>
  <q-card flat bordered class="col-12 q-mt-sm">
    <q-separator />
    <div class="col-12 row q-pa-md">
      <div class="row col-12">
        <div class="row col-12 q-col-gutter-sm">
          <div>
            <q-btn
              color="blue-9"
              icon="mdi-square-edit-outline"
              outline
              @click="$router.push('/exit-Interview/edit-question')"
              ><span class="q-pl-sm">แก้ไขคำถาม</span></q-btn
            >
          </div>
          <q-space />
          <q-input
            class="col-xs-12 col-sm-3 col-md-2"
            standout
            dense
            v-model="filterKeyword"
            ref="filterRef"
            outlined
            debounce="300"
            placeholder="ค้นหา"
          >
            <template v-slot:append>
              <q-icon v-if="filterKeyword == ''" name="search" />
              <q-icon
                v-if="filterKeyword !== ''"
                name="clear"
                class="cursor-pointer"
                @click="resetFilter"
              />
            </template>
          </q-input>
          <q-select
            v-model="visibleColumns"
            multiple
            outlined
            dense
            options-dense
            :display-value="$q.lang.table.columns"
            emit-value
            map-options
            :options="columns"
            option-value="name"
            options-cover
            style="min-width: 150px"
            class="col-xs-12 col-sm-3 col-md-2"
          />
        </div>
        <div class="col-12 q-pt-sm">
          <d-table
            :columns="columns"
            :rows="rows"
            :filter="filterKeyword"
            row-key="id"
            :visible-columns="visibleColumns"
          >
            <template v-slot:header="props">
              <q-tr :props="props">
                <q-th v-for="col in props.cols" :key="col.name" :props="props">
                  <span class="text-weight-medium">{{ col.label }}</span>
                </q-th>
                <q-th auto-width />
              </q-tr>
            </template>
            <template v-slot:body="props">
              <q-tr :props="props" class="cursor-pointer">
                <q-td
                  key="no"
                  :props="props"
                  @click="
                    router.push(`/exit-Interview/questionnair/${props.row.id}`)
                  "
                >
                  {{ props.rowIndex + 1 }}
                </q-td>
                <q-td
                  key="fullname"
                  :props="props"
                  @click="
                    router.push(`/exit-Interview/questionnair/${props.row.id}`)
                  "
                >
                  {{ props.row.fullname }}
                </q-td>
                <q-td
                  key="realReason"
                  :props="props"
                  @click="
                    router.push(`/exit-Interview/questionnair/${props.row.id}`)
                  "
                >
                  {{ props.row.realReason }}
                </q-td>
                <q-td
                  key="notExitFactor"
                  :props="props"
                  @click="
                    router.push(`/exit-Interview/questionnair/${props.row.id}`)
                  "
                >
                  {{ props.row.notExitFactor }}
                </q-td>
                <q-td
                  key="futureWork"
                  :props="props"
                  @click="
                    router.push(`/exit-Interview/questionnair/${props.row.id}`)
                  "
                >
                  {{ props.row.futureWork ? "ใช่" : "ไม่" }}
                </q-td>
                <q-td
                  key="futureWorkReason"
                  :props="props"
                  @click="
                    router.push(`/exit-Interview/questionnair/${props.row.id}`)
                  "
                >
                  {{ props.row.futureWorkReason }}
                </q-td>
                <q-td
                  key="havejob"
                  :props="props"
                  @click="
                    router.push(`/exit-Interview/questionnair/${props.row.id}`)
                  "
                >
                  {{ props.row.havejob ? "ใช่" : "ไม่" }}
                </q-td>

                <q-td
                  key="havejobReason"
                  :props="props"
                  @click="
                    router.push(`/exit-Interview/questionnair/${props.row.id}`)
                  "
                >
                  <div class="table_ellipsis">
                    {{ props.row.havejobReason }}
                  </div>
                </q-td>
                <q-td
                  key="appointDate"
                  :props="props"
                  @click="
                    router.push(`/exit-Interview/questionnair/${props.row.id}`)
                  "
                >
                  {{
                    props.row.appointDate == null ? "-" : props.row.appointDate
                  }}
                </q-td>
                <q-td
                  key="datetext"
                  :props="props"
                  @click="
                    router.push(`/exit-Interview/questionnair/${props.row.id}`)
                  "
                >
                  {{ props.row.datetext }}
                </q-td>
                <q-td auto-width>
                  <q-btn
                    v-if="!props.row.appointDate"
                    icon="mdi-calendar"
                    size="12px"
                    color="blue-7"
                    flat
                    round
                    dense
                    @click="openModalCalendar(props.row)"
                  >
                    <q-tooltip>วันนัดหมายเพื่อทําการสัมภาษณ์การลาออก</q-tooltip>
                  </q-btn>
                </q-td>
              </q-tr>
            </template>
          </d-table>
        </div>
      </div>
    </div>
  </q-card>

  <!-- dialog กำหนดวันหนัดหมายสัมภาษณ์ -->
  <q-dialog v-model="modal" persistent>
    <q-card style="width: 800px">
      <q-form ref="myForm">
        <DialogHeader
          title="กําหนดวันนัดหมายเพื่อทําการสัมภาษณ์การลาออก"
          :close="closeModal"
        />
        <q-separator />
        <q-card-section class="q-p-sm q-gutter-md">
          <div class="col-xs-12 col-sm-12 col-md-12">
            <datepicker
              menu-class-name="modalfix"
              v-model="dateBreak"
              :locale="'th'"
              autoApply
              :enableTimePicker="false"
              week-start="0"
            >
              <template #year="{ year }">{{ year + 543 }}</template>
              <template #year-overlay-value="{ value }">{{
                parseInt(value + 543)
              }}</template>
              <template #trigger>
                <q-input
                  outlined
                  dense
                  lazy-rules
                  :model-value="
                    dateBreak !== null ? date2Thai(dateBreak) : null
                  "
                  hide-bottom-space
                  :label="`${' วันนัดหมายเพื่อทําการสัมภาษณ์การลาออก'}`"
                  :rules="[
                    (val) => !!val || `${'กรุณาเลือกลงวันที่'}`,
                    (val) =>
                      validationDate(val) ||
                      `${'วันที่นัดหมายต้องมากกว่าวันที่สร้าง'}`,
                  ]"
                >
                  <template v-slot:prepend>
                    <q-icon
                      name="event"
                      class="cursor-pointer"
                      style="color: var(--q-primary)"
                    >
                    </q-icon>
                  </template>
                </q-input>
              </template>
            </datepicker>
          </div>
        </q-card-section>
        <q-separator />
        <DialogFooter :editvisible="true" :save="saveAppoint" />
      </q-form>
    </q-card>
  </q-dialog>
</template>
<style scoped lang="scss"></style>
